"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Sphere = void 0;
var Vec3_1 = require("../../math/Vec3");
var Sphere = /** @class */ (function () {
    function Sphere(center, radius) {
        if (center === void 0) { center = (0, Vec3_1.v3)(); }
        if (radius === void 0) { radius = 0; }
        this.center = center;
        this.radius = radius;
    }
    Sphere.prototype.applyMat4 = function (mat) {
        throw new Error('Method not implemented.');
    };
    Sphere.prototype.setComponents = function (cx, cy, cz, radius) {
        this.center.set(cx, cy, cz);
        this.radius = radius;
        return this;
    };
    Sphere.prototype.copy = function (sphere) {
        this.center.copy(sphere.center);
        this.radius = sphere.radius;
        return this;
    };
    Sphere.prototype.clone = function () {
        return new Sphere().copy(this);
    };
    return Sphere;
}());
exports.Sphere = Sphere;
