# 矩阵

## 矩阵的各种
1.  **行矩阵,列矩阵**  
    ```
    m×n阶矩阵中，m=1，称为行矩阵，也称为n维行向量;n=1，称为列矩阵，也称为m维列向量。
    
    ```
   ***
2. **零矩阵**   
   ```
   矩阵中所有元素都为 0
   ```
 
$$ 
    a^2+b^2=c^2  
$$
$$
\left| 
\begin{matrix}
   0 & 0 & 0 & 0 & 0\\ 
   0 & 0 & 0 & 0 & 0\\ 
   0 & 0 & 0 & 0 & 0\\ 
   0 & 0 & 0 & 0 & 0
  \end{matrix}  
  \right|
$$  
* **可逆矩阵**：
$$ 
| A |≠0
$$

* **对称矩阵**：
$$ 
  A^T = A  
$$

* **正交矩阵**
$$
A^TA=AA^T=E
$$

* **等价矩阵**
 如果这两个矩阵满足 
 $$ B=QAP $$
 （$P$是n×n阶可逆矩阵，$Q$是m×m阶可逆矩阵），那么这两个矩阵之间是等价关系

* **初等矩阵**：由单位矩阵E经过一次初等变换得到的矩阵称为初等矩阵。
  
* **正定矩阵**: 
  $$z^TMz> 0$$
  其中$z^T$ 表示$z$的转置，就称$M$为正定矩阵。
1. 正定矩阵的行列式恒为正；
   $$ |M|>0 $$
2. 实对称矩阵$A$正定当且仅当$A$与单位矩阵合同；
3. 若$A$是正定矩阵，则$A$的逆矩阵也是正定矩阵；
4. 两个正定矩阵的和是正定矩阵；
5. 正实数与正定矩阵的乘积是正定矩阵。

* **合同矩阵**：设$A$,$B$是两个$n$阶方阵，若存在可逆矩阵$C$，使得
$$ C^TAC=B  $$
则称方阵$A$与$B$合同，记作 $A$≃$B$。

合同关系是一个等价关系，也就是说满足：
1. 反身性：任意矩阵都与其自身合同；
2. 对称性：$A$合同于$B$，则可以推出$B$合同于$A$；
3. 传递性：$A$合同于$B$，$B$合同于$C$，则可以推出$A$合同于$C$；
4. 合同矩阵的秩相同。
矩阵合同的主要判别法：
设$A$,$B$均为复数域上的n阶对称矩阵,则$A$与$B$在复数域上合同等价于$A$与$B$的秩相同.
　　设$A$,$B$均为实数域上的n阶对称矩阵,则$A$与$B$在实数域上合同等价于$A$与$B$有相同的正、负惯性指数（即正、负特征值的个数相等）。

* **相似矩阵**: 
  > 在线性代数中，相似矩阵是指存在相似关系的矩阵。设$A$，$B$为$n$阶矩阵，如果有$n$阶可逆> 矩阵$P$存在，使得
  > $$ P^{-1}AP=B  \\$$ 
  > 则称矩阵$A$与$B$相似，记为   $A$~ $B$。 
  >对于 设$A$，$B$和$C$是任意同阶方阵，则有：  
  >>1. 反身性：$A$ ~ $A$
  >>2. 对称性：若$A$~ $B$，则 $B$~ $A$
  >>3. 传递性：若$A$~ $B$，$B$~ $C$，则$A$~ $C$
  >>4. 若$A$~ $B$，则$r(A)=r(B)$，$|A|=|B|$，$tr(A)=tr(B)$。
  >>5. 若$A$~ $B$，且$A$可逆，则$B$也可逆，且$B$~ $A$。
  >>6. 若$A$~ $B$，则$A$与$B$
两者的秩相等；
两者的行列式值相等；
两者的迹数相等；
两者拥有同样的特征值，尽管相应的特征向量一般不同；
两者拥有同样的特征多项式；
两者拥有同样的初等因子。
7. 若$A$与对角矩阵相似，则称$A$为可对角化矩阵，若$n$阶方阵$A$有$n$个线性无关的特征向量，则称$A$为单纯矩阵。
8. 相似矩阵具有相同的可逆性，当它们可逆时，则它们的逆矩阵也相似。